///home/berryj/link/bin/genMethods "-t" "Attribute<String>*" "-I" "LINK/graph/Attribute.h" "-d" "graph" "-y" "display_attribute_stringptr" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/Attribute.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_attribute_stringptr(SCM, SCM, int);

typedef Attribute<String>* _Attribute_String__;

#define _Attribute_String__DATA(x) ((Attribute<String>**) (EXTDATA(x)))
#define _Attribute_String__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Attribute<String>* >::type))
#define _Attribute_String__ISNT_DATA(x) (!_Attribute_String__IS_DATA(x))

#define _Attribute_String__CXX_DATA(x) (*(Attribute<String>**) (EXTDATA(VAL(x))))
#define _Attribute_String__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Attribute<String>* >::type))
#define _Attribute_String__CXX_ISNT_DATA(x) (!_Attribute_String__CXX_IS_DATA(x))


static SCM is_Attribute_String__(SCM i)
{
	if (_Attribute_String__CXX_IS_DATA(i))
		return Truth;
	return Ntruth;
}

PRIMITIVE STk_init__Attribute_String__()
{
	Wrapper<_Attribute_String__>::type = STk_new_CXXwrapper_id(
			Wrapper<_Attribute_String__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			display_attribute_stringptr,
			(void (*)(SCM x))0,
			(void (*)(SCM x))0);
	Tcl_InitHashTable(&Register<_Attribute_String__>::objTable, TCL_ONE_WORD_KEYS);
	STk_add_new_cpp_primitive("Attribute-String?", tc_subr_1,
	(PRIMITIVE (*)(...))  is_Attribute_String__);
	return UNDEFINED;
}

void genExtra_Attribute_String__Methods(void);

PRIMITIVE STk_init_methods__Attribute_String__()
{
	genExtra_Attribute_String__Methods();
	return UNDEFINED;
}
